//+------------------------------------------------------------------+
//|                                  _HPCS_PinesScript_MT4_V01_E.mq4 |
//|                        Copyright 2011-2021, HPC Sphere Pvt. Ltd. |
//|                                         http://www.hpcsphere.com |
//+------------------------------------------------------------------+
#property copyright " 2011-2021 HPC Sphere Pvt Ltd."
#property link      "http://www.hpcsphere.com"
#property version   "1.00"
#property strict
#property indicator_chart_window
#property indicator_buffers 6

double Buffer_1[],Buffer_2[],Buffer_3[], Buffer_4[],Buffer_5[],Buffer_6[];

input int LEFT_BAR_NUMBER=48;  //   High Left Bar Number
input int RIGHT_BAR_NUMBER=48;//   High Right Bar Number
input int HighLINE_WIDTH=1;//  High Line Width
input color HighLINE_COLOR=DarkOrange;//   High Line Color

input int SWING_LOW_LEFT_BAR_NUMBER=48;// LOW LEFT BAR NUMBER
input int SWING_LOW_RIGHT_BAR_NUMBER=48;// LOW RIGHT BAR NUMBER
input int LowLINE_WIDTH=1;//  Low Line Width
input color LowLINE_COLOR=DarkTurquoise;//   Low Line Color




bool LEFT_BAR_PERFECT=false; //  High Left Bar Perfect
bool RIGHT_BAR_PERFECT=false;// High Right Bar Perfect

bool SWING_LOW_LEFT_BAR_PERFECT=false;// LOW LEFT BAR PERFECT
bool SWING_LOW_RIGHT_BAR_PERFECT=false;// LOW RIGHT BAR PERFECT

bool PLOT_LINE=true;// High Plot Line
bool SWING_LOW_PLOT_LINE=true;// LOW PLOT LINE



int DIAMOND_SIZE1=1;// High Diamond Size
color DIAMOND_COLOR1=Bisque;// High Diamond Color
int DIAMOND_SIZE2=2;// Low Diamond Size
color DIAMOND_COLOR2=PaleTurquoise;// Low Diamond Color
int Counted_bars;
bool lpt=false,rpt=false,lpf=false,rpf=false;
bool llpt=false,lrpt=false,llpf=false,lrpf=false;
double prev_sh=0.0,prev_sh2 = 0.0;
double lprev_sh=0.0,lprev_sh2 = 0.0;
int j;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   IndicatorDigits(5);

   SetIndexBuffer(0,Buffer_1);
   SetIndexStyle(0,DRAW_LINE,0,HighLINE_WIDTH,HighLINE_COLOR);
   SetIndexEmptyValue(0,0);

   SetIndexBuffer(1,Buffer_2);
   SetIndexStyle(1,DRAW_ARROW,0,DIAMOND_SIZE1,DIAMOND_COLOR1);
   SetIndexArrow(1,115);
   SetIndexEmptyValue(1,0);

   SetIndexBuffer(2,Buffer_3);
   SetIndexEmptyValue(2,0);

   SetIndexBuffer(3,Buffer_4);
   SetIndexStyle(3,DRAW_LINE,0,LowLINE_WIDTH,LowLINE_COLOR);
   SetIndexEmptyValue(3,0);

   SetIndexBuffer(4,Buffer_5);
   SetIndexStyle(4,DRAW_ARROW,0,DIAMOND_SIZE2,DIAMOND_COLOR2);
   SetIndexArrow(4,115);
   SetIndexEmptyValue(4,0);

   SetIndexBuffer(5,Buffer_6);
   SetIndexEmptyValue(5,0);
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   int limit,i;

   Counted_bars = IndicatorCounted();
   if(Counted_bars==0)
     {
      limit = Bars - Counted_bars - LEFT_BAR_NUMBER-1;
     }
   else
     {
      limit = Bars - Counted_bars + RIGHT_BAR_NUMBER;
      // prev_sh = High[RIGHT_BAR_NUMBER+1];
     }

   for(i=limit; i>RIGHT_BAR_NUMBER; i--)
     {

      if(RIGHT_BAR_PERFECT==true)
        {
         rpt=Highcheck_rp(i);
        }
      else
         if(RIGHT_BAR_PERFECT==false)
           {
            rpf=Highcheck_r(i);
           }
      if(LEFT_BAR_PERFECT==true)
        {
         lpt=Highcheck_lp(i);
        }
      else
         if(LEFT_BAR_PERFECT==false)
           {
            lpf=Highcheck_l(i);
           }

      if(LEFT_BAR_PERFECT==true && RIGHT_BAR_PERFECT==true && lpt==true && rpt==true)
        {
         if(PLOT_LINE==true)
           {
            Buffer_1[i]=High[i];
            prev_sh=High[i];

           }
         else
           {
            Buffer_3[i] = High[i];
            prev_sh2 = High[i];
           }
         Buffer_2[i]=High[i];
        }
      else
        {
         Buffer_1[i]=prev_sh;
         if(PLOT_LINE == false)
           {
            Buffer_3[i] = prev_sh2;
           }
        }
      if(LEFT_BAR_PERFECT==true && RIGHT_BAR_PERFECT==false && lpt==true && rpf==true)
        {

         if(PLOT_LINE==true)
           {
            Buffer_1[i]=High[i];
            prev_sh=High[i];

           }
         else
           {
            Buffer_3[i] = High[i];
            prev_sh2 = High[i];
           }
         Buffer_2[i]=High[i];
        }
      else
        {
         Buffer_1[i]=prev_sh;
         if(PLOT_LINE == false)
           {
            Buffer_3[i] = prev_sh2;
           }
        }
      if(LEFT_BAR_PERFECT==false && RIGHT_BAR_PERFECT==true && lpf==true && rpt==true)
        {
         if(PLOT_LINE==true)
           {
            Buffer_1[i]=High[i];
            prev_sh=High[i];

           }
         else
           {
            Buffer_3[i] = High[i];
            prev_sh2 = High[i];
           }
         Buffer_2[i]=High[i];
        }
      else
        {
         Buffer_1[i]=prev_sh;
         if(PLOT_LINE == false)
           {
            Buffer_3[i] = prev_sh2;
           }
        }
      if(LEFT_BAR_PERFECT==false && RIGHT_BAR_PERFECT==false && lpf==true && rpf==true)
        {
         if(PLOT_LINE==true)
           {
            Buffer_1[i]=High[i];
            prev_sh=High[i];
           }
         else
           {
            Buffer_3[i] = High[i];
            prev_sh2 = High[i];
           }
         Buffer_2[i]=High[i];
        }
      else
        {
         Buffer_1[i]=prev_sh;
         if(PLOT_LINE == false)
           {
            Buffer_3[i] = prev_sh2;
           }
        }
     }

//--------------------------------------------------Low Lines ------------------------------------------------------
   for(i=limit; i>SWING_LOW_RIGHT_BAR_NUMBER; i--)
     {
      if(SWING_LOW_RIGHT_BAR_PERFECT==true)
        {
         lrpt=check_rp(i);
        }
      else
         if(SWING_LOW_RIGHT_BAR_PERFECT==false)
           {
            lrpf=check_r(i);
           }
      if(SWING_LOW_LEFT_BAR_PERFECT==true)
        {
         llpt=check_lp(i);
        }
      else
         if(SWING_LOW_LEFT_BAR_PERFECT==false)
           {
            llpf=check_l(i);
           }
      if(SWING_LOW_LEFT_BAR_PERFECT==true && SWING_LOW_RIGHT_BAR_PERFECT==true && llpt==true && lrpt==true)
        {
         if(SWING_LOW_PLOT_LINE==true)
           {
            Buffer_4[i]=Low[i];
            lprev_sh=Low[i];
           }
         else
           {
            Buffer_6[i] = Low[i];
            lprev_sh2 = Low[i];
           }
         Buffer_5[i]=Low[i];
        }
      else
        {
         Buffer_4[i]=lprev_sh;
         if(SWING_LOW_PLOT_LINE == false)
           {
            Buffer_6[i] = lprev_sh2;
           }
        }
      if(SWING_LOW_LEFT_BAR_PERFECT==true && SWING_LOW_RIGHT_BAR_PERFECT==false && llpt==true && lrpf==true)
        {
         if(SWING_LOW_PLOT_LINE==true)
           {
            Buffer_4[i]=Low[i];
            lprev_sh=Low[i];
           }
         else
           {
            Buffer_6[i] = Low[i];
            lprev_sh2 = Low[i];
           }
         Buffer_5[i]=Low[i];
        }
      else
        {
         Buffer_4[i]=lprev_sh;
         if(SWING_LOW_PLOT_LINE == false)
           {
            Buffer_6[i] = lprev_sh2;
           }
        }
      if(SWING_LOW_LEFT_BAR_PERFECT==false && SWING_LOW_RIGHT_BAR_PERFECT==true && llpf==true && lrpt==true)
        {
         if(SWING_LOW_PLOT_LINE==true)
           {
            Buffer_4[i]=Low[i];
            lprev_sh=Low[i];
           }
         else
           {
            Buffer_6[i] = Low[i];
            lprev_sh2 = Low[i];
           }
         Buffer_5[i]=Low[i];
        }
      else
        {
         Buffer_4[i]=lprev_sh;
         if(SWING_LOW_PLOT_LINE == false)
           {
            Buffer_6[i] = lprev_sh2;
           }
        }
      if(SWING_LOW_LEFT_BAR_PERFECT==false && SWING_LOW_RIGHT_BAR_PERFECT==false && llpf==true && lrpf==true)
        {
         if(SWING_LOW_PLOT_LINE==true)
           {
            Buffer_4[i]=Low[i];
            lprev_sh=Low[i];
           }
         else
           {
            Buffer_6[i] = Low[i];
            lprev_sh2 = Low[i];
           }
         Buffer_5[i]=Low[i];
        }
      else
        {
         Buffer_4[i]=lprev_sh;
         if(SWING_LOW_PLOT_LINE == false)
           {
            Buffer_6[i] = lprev_sh2;
           }
        }
     }




//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
int Highcheck_l(int k)
  {

   for(j=1; j<=LEFT_BAR_NUMBER; j++)
     {
      if(k+j<Bars)
        {
         if(High[k]<=High[k+j])
           {
            return false;
           }
        }
     }
   return true;
  }
///======================================================================
int Highcheck_r(int k)
  {

   for(j=1; j<=RIGHT_BAR_NUMBER; j++)
     {
      if(k-j>=0)
        {
         if(High[k]<=High[k-j])
           {
            return false;
           }
        }
     }
   return true;
  }
//=======================================================================
int Highcheck_lp(int k)
  {
   for(j=0; j<LEFT_BAR_NUMBER; j++)
     {
      if(k+j+1<Bars)
        {
         if(High[k+j]<=High[k+j+1])
           {
            return false;
           }
        }
     }
   return true;
  }

//=====================================================================

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int Highcheck_rp(int k)
  {

   for(j=0; j<RIGHT_BAR_NUMBER; j++)
     {
      if(k-j-1>=0 && k-j<Bars)
        {
         if(High[k-j]<=High[k-j-1])
           {
            return false;
           }
        }
     }
   return true;
  }
//+------------------------------------------------------------------+
int check_l(int k)
 {  
 
  for(j=1; j<=SWING_LOW_LEFT_BAR_NUMBER; j++)
  {
     if(k+j<Bars)
     {
      if(Low[k]>=Low[k+j])
      {
         return false;
      }
     }
  }
  return true; 
 }
///======================================================================
int check_r(int k)
 {
  
  for(j=1; j<=SWING_LOW_RIGHT_BAR_NUMBER; j++)
  {
     if(k-j>=0)
     {
         if(Low[k]>=Low[k-j])
         {
            return false;
         }
     }
  }
  return true; 
 } 
//=======================================================================
int check_lp(int k)
 { 
  for(j=0; j<SWING_LOW_LEFT_BAR_NUMBER; j++)
  {
     if(k+j+1<Bars)
     {
         if(Low[k+j]>=Low[k+j+1])
         {
            return false;
         }
      }
  }
  return true; 
 } 

//=====================================================================

int check_rp(int k)
 {

  for(j=0; j<SWING_LOW_RIGHT_BAR_NUMBER; j++)
  {
      if(k-j-1>=0 && k-j<Bars)
      {
         if(Low[k-j]>=Low[k-j-1])
         {
            return false;
         }
      }
  }
  return true; 
 } 
